// Linked List implementation with Javascript see http://www.nczonline.net/blog/2009/04/21/computer-science-in-javascript-doubly-linked-lists/
var LinkedList = function LinkedList() {
  this._head = null;
  this._tail = null;
  this._size = 0;
};

LinkedList.prototype = {
  add: function (data) {
    var node = {
      data: data,
      next: null,
      prev: null
    };
    if(this._size === 0) {
      this._head = node;
      this._tail = node;
    } else {
      this._tail.next = node;
      node.prev = this._tail;
      this._tail = node;
    }
    this._size++;
  },
  remove: function (index) {
    if(index < 0 || index >= this._size) {
      return null;
    } else {
      var current, tmp;
      if(index === 0) {
        current = this._head;
        this._head = current.next;
        if(this._head === null) {
          this._tail = null;
        } else {
          this._head.prev = null;
        }
      } else if (index === this._size - 1) {
        current = this._tail;
        this._tail = current.prev;
        this._tail.next = null;
      } else {
        var i;
        if(index > this._size/2) {
          i = this._size - 1;
          current = this._tail;
          while(i > index) {
            i--;
            tmp = current;
            current = current.prev;
          }
          tmp.prev = current.prev.next;
          current.prev.next = tmp;
          if(index === this._size - 2) {
            this._tail.prev = current.prev;
          }
        } else {
          i = 0;
          current = this._head;
          while(i < index) {
            i++;
            tmp = current;
            current = current.next;
          }
          current.next.prev = tmp;
          tmp.next = current.next;
        }
      }
      this._size--;
      return current.data;
    }
  },
  get: function (index) {
    if(index > -1 && index < this._size) {
      var current, i;
      if(index === 0) {
        return this._head.data;
      } else if(index > this._size/2) {
        current = this._tail;
        i = this._size - 1;
        while(i > index) {
          i--;
          current = current.prev;
        }
        return current.data;
      } else {
        current = this._head;
        i = 0;
        while(i < index) {
          i++;
          current = current.next;
        }
        return current.data;
      }
    } else {
      return null;
    }
  },
  size: function () {
    return this._size;
  }
};

module.exports = LinkedList;