var assert = require('assert'),
  Queue = require('../lib/Queue');

describe('[Lib] Queue', function () {
  it('should be able instantiate a queue object of size 0', function () {
    var queue = new Queue();
    assert.equal(0, queue.size());
    assert.equal("object", typeof queue);
  });
  it('should be able to enqueue elements and update the queue size correctly', function () {
    var queue = new Queue();
    queue.enqueue("first");
    queue.enqueue("second");
    queue.enqueue("third");
    queue.enqueue("fourth");
    queue.enqueue("fifth");
    assert.equal(5, queue.size());
  });
  it('should be able to enqueue and dequeue elements in FIFO order, update queue size and return null if queue is empty', function () {
    var queue = new Queue();
    queue.enqueue("first");
    queue.enqueue("second");
    queue.enqueue("third");
    queue.enqueue("fourth");
    assert.equal("first", queue.dequeue());
    assert.equal("second", queue.dequeue());
    assert.equal("third", queue.dequeue());
    assert.equal("fourth", queue.dequeue());
    assert.equal(null, queue.dequeue());
  });
  it('should be able to peek the next element to be dequeued without removing it', function () {
    var queue = new Queue();
    queue.enqueue("first");
    queue.enqueue("second");
    queue.enqueue("third");
    queue.enqueue("fourth");
    assert.equal(4, queue.size());
    assert.equal("first", queue.peek());
    assert.equal(4, queue.size());
  });
});