var assert = require('assert'),
  Stack = require('../lib/Stack');

describe('[Lib] Stack', function () {
  it('should be able instantiate a stack of size 0', function () {
    var stack = new Stack();
    assert.equal(0, stack.size());
    assert.equal("object", typeof stack);
  });
  it('should be able to add elements to stack and update the actual stack size correctly', function () {
    var stack = new Stack();
    stack.push("first");
    stack.push("second");
    stack.push("third");
    stack.push("fourth");
    stack.push("fifth");
    assert.equal(5, stack.size());
  });
  it('should be able to get elements of the stack in LIFO order', function () {
    var stack = new Stack();
    stack.push("first");
    stack.push("second");
    stack.push("third");
    stack.push("fourth");
    assert.equal("fourth", stack.pop());
    assert.equal("third", stack.pop());
    assert.equal("second", stack.pop());
    assert.equal("first", stack.pop());
    assert.equal(null, stack.pop());    
  });
});